Lua_KunXuHolyLandEmbattleWindow = class("Lua_KunXuHolyLandEmbattleWindow", Lua_Window);
function Lua_KunXuHolyLandEmbattleWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_KunXuHolyLandEmbattleWindow";
	self.skinName = "KunXuHolyLandEmbattleWindow_skin";
	self.isSingleShowWin = true;
	self.isFullSizeWin = true;
	-- self.showBlackMask = true;
	self.showBackBtn = true;
	-- self.showWinBg = true;

	self.lineup_type = 31; -- 英雄布阵配置表-昆墟圣地
	self.template_id = 1030; -- 模板id
	self.winSceneId = Lua_SceneDefine.KUNXU_HOLYLAND;
	-- self.winBgPath = "/images/kunXuHolyLand/xui_kxsd_bj_4.jpg";
 --    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_KunXuHolyLandEmbattleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setLocation(75, 70);
	self.canPassFight = DataCenter.kunXuHolyLandData.switchState == 1;
	self.passFightBox.selected = self.canPassFight;
 	self.passFightBox:setLocation(-54, 89);

	self.leftMonsterNum = Lua_NumberImage.new(self.content);
	-- self.leftMonsterNum:setRectAnchor(7);
	self.leftMonsterNum:setLocation(-199, 298, 0);
	self.leftMonsterNum.pivot = 0;
	self.leftMonsterNum.numOffsetX = -4;
	self.leftMonsterNum.numAtlas = "number";
	self.leftMonsterNum.firstStr = "xui_zl1_number_10";
	self.leftMonsterNum.preStr = "xui_zl1_number_0";

	self.rightMonsterNum = Lua_NumberImage.new(self.content);
	self.rightMonsterNum:setLocation(175, 306, 0);
	self.rightMonsterNum.pivot = 0;
	self.rightMonsterNum.numOffsetX = -4;
	self.rightMonsterNum.numAtlas = "number";
	self.rightMonsterNum.firstStr = "xui_zl1_number_10";
	self.rightMonsterNum.preStr = "xui_zl1_number_0";

	self.leftPlayerNum = Lua_NumberImage.new(self.content);
	self.leftPlayerNum:setLocation(-155, -162, 0);
	self.leftPlayerNum.pivot = 0;
	self.leftPlayerNum.numOffsetX = -4;
	self.leftPlayerNum.numAtlas = "number";
	self.leftPlayerNum.firstStr = "xui_zl1_number_10";
	self.leftPlayerNum.preStr = "xui_zl1_number_0";

	self.rightPlayerNum = Lua_NumberImage.new(self.content);
	self.rightPlayerNum:setLocation(169, -162, 0);
	self.rightPlayerNum.pivot = 0;
	self.rightPlayerNum.numOffsetX = -4;
	self.rightPlayerNum.numAtlas = "number";
	self.rightPlayerNum.firstStr = "xui_zl1_number_10";
	self.rightPlayerNum.preStr = "xui_zl1_number_0";

	self.levelNum = Lua_NumberImage.new(self.content);
	self.levelNum:setRectAnchor(7);
	self.levelNum:setLocation(-2, 410, 0);
	self.levelNum.pivot = 0;
	self.levelNum.numOffsetX = -4;
	self.levelNum.numAtlas = "number";
	self.levelNum.firstStr = "xui_kxsd_number_12";
	self.levelNum.preStr = "xui_kxsd_number_";
	self.levelNum.lastStr = "xui_kxsd_number_11";

	self.levelSp:addClickFuntion(self, self.onClickLevelSp);
	self.passFightBox:addBoxChange(self, self.onClickPassFightBox);
	self.startSp:addClickFuntion(self, self.onClickStartSp);
	self.leftLineUpSp:addClickFuntion(self, self.onClickLeftTeam);
	self.rightLineUpSp:addClickFuntion(self, self.onClickRightTeam);
	self:addLuaEvent("UPDATE_KUNXU_HEROLIST", self, self.updateHeroList); -- 更新英雄模型、战力
	self:addLuaEvent("UPDATE_KUNXU_UPDATEPASSFIGHTBOX_STATE", self, self.updatePassFightBoxState); -- 更新是否跳过战斗
end

function Lua_KunXuHolyLandEmbattleWindow:showWin(param)
	self:superCall("showWin", param);
	-- self.winBg:setLocation(0, 39);
	self.levelId = param;
	self.loadedModelCount = 0;
	self.mondl_len = 2;
	DataCenter.kunXuHolyLandData.openFightId = self.levelId;

	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(param);
	local monsterList = levelInfo:getMonsterModel();


	local levelNum = levelInfo.level;
	levelNum = levelNum == 10 and "." or levelNum;
	self.levelNum.num = levelNum;

	local fightNum = monsterList[1].force;
	fightNum = fightNum == nil and 0 or fightNum;
	self.leftMonsterNum.num = fightNum;
	fightNum = monsterList[2].force;
	fightNum = fightNum == nil and 0 or fightNum;
	self.rightMonsterNum.num = fightNum;

	local descList = levelInfo.starList;
	self:setDescList(descList);

	self.leftMonsterId = levelInfo.monsterId;
	self.rightMonsterId = levelInfo.monsterId;
	self:showModel();
end

function Lua_KunXuHolyLandEmbattleWindow:onClickLeftTeam()
	self.teamIndex = 1;
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_KUNXU);
	DataCenter.preLoadData:preShowScene("Lua_KunXuHolyLandLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_KunXuHolyLandEmbattleWindow:onSceneShow(param)
	local data = { 
		template_id = Lua_FightDefine.TEMPLATE_ID_KUNXU, 
		monster_player_id = self.leftMonsterId,
		teamIndex = self.teamIndex,
		stage_id = self.levelId
		 };
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end


function Lua_KunXuHolyLandEmbattleWindow:onClickRightTeam()
	self.teamIndex = 2;
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_KUNXU);
	DataCenter.preLoadData:preShowScene("Lua_KunXuHolyLandLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_KunXuHolyLandEmbattleWindow:onClickStartSp()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();

    if self.canPassFight then
    	Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.levelId);
    else
    	self:onClickLeftTeam();
    end
end

function Lua_KunXuHolyLandEmbattleWindow:onClickPassFightBox()
	local showState = DataCenter.kunXuHolyLandData.switchState == 1;
	self.passFightBox.selected = showState;

	if not DataCenter.kunXuHolyLandData.canPassFight then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sGetPassFight(showState and 0 or 1); --请求跳过战斗开关
end

function Lua_KunXuHolyLandEmbattleWindow:updatePassFightBoxState()
	local showState = DataCenter.kunXuHolyLandData.switchState == 1;
	self.passFightBox.selected = showState;
	self.canPassFight = showState;
end

function Lua_KunXuHolyLandEmbattleWindow:setDescList(descList)
	if self.descList == nil then
		self.descList = {};
	end

	local item;
	for i = 1, #descList do
		item = self.descList[i];
		if item == nil then
			item = Lua_KunXuHolyLandEBDescItem.new(self.content);
			item:setRectAnchor(7);
			item:setLocation(-48, 340 - 47 * (i - 1));
			self.descList[i] = item;
		end
		item:setData(descList[i]);
	end
end

function Lua_KunXuHolyLandEmbattleWindow:onClickLevelSp()
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLevelWindow", Lua_WinParam.ACTION_OPEN);	
end

function Lua_KunXuHolyLandEmbattleWindow:updateHeroList()
 	local leftForce, leftHeroId, rightForce, rightHeroId = DataCenter.kunXuHolyLandData:getHeroInfo();
 	self.leftPlayerNum.num = leftForce;
	self.rightPlayerNum.num = rightForce;

	self:updateHeroByHeroId(leftHeroId, true, 3);
	self:updateHeroByHeroId(rightHeroId, true, 4);
end

function Lua_KunXuHolyLandEmbattleWindow:showModel()
	self:updatePosEffect();

	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	local monsterList = levelInfo:getMonsterModel();
	local leftMonsterId = monsterList[1].monsterId;
	local rightMonsterId = monsterList[2].monsterId;

	local heroId;
	local cfgData = Lua_MonsterConfigData.getMonsterConfig(leftMonsterId);-- leftMonster
	self:updateHeroByHeroId(cfgData ~= nil and cfgData.heroId or nil, false, 1);
	cfgData = Lua_MonsterConfigData.getMonsterConfig(rightMonsterId); 
	self:updateHeroByHeroId(cfgData ~= nil and cfgData.heroId or nil, false, 2);-- rightMonster

    -- 英雄
    self:updateHeroList();
end

function Lua_KunXuHolyLandEmbattleWindow:updatePosEffect()
	if not self.bCreateStandEff then
		self.bCreateStandEff = true;
		local posTab = DataCenter.kunXuHolyLandUtil.modelPosList;
		for i = 1, 4 do
			local data = SceneEffectData();
		    data.roleId = i;
		    data.sceneId = Lua_SceneDefine.KUNXU_HOLYLAND;
		    data.kind = Lua_ThingDefine.SCENE_EFFECT;
		    data.px = posTab[i][1];
		    data.py = 0;
		    data.pz = posTab[i][3];
		    data.canBeClick = false;
		    data.effectFile = "buzhen_guangquan_01";
		    data.effectName = "buzhen_guangquan_01";
		    data.showShadow = false;
		    data.isShowName = false;
		    data.toLand = false;
		    data.rotX = 0;
		    data.rotY = 0;
		    data.rotZ = 0;
		    data.scaX = 1;
		    data.scaY = 1;
		    data.scaZ = 1;
		    ThingUtil.instance:addSceneEffect(data, true);
		end
	end
end

function Lua_KunXuHolyLandEmbattleWindow:updateHeroByHeroId(heroId, bUniqueId, index)
	if self.lastHeroIdTab == nil then
		self.lastHeroIdTab = {};
	end

	local lastId = self.lastHeroIdTab[index];
	if lastId ~= nil and lastId ~= heroId then
		ThingUtil.instance:removeThing(self.winSceneId, 0, lastId);
	end
	self.lastHeroIdTab[index] = heroId;

	local heroVo;
	if bUniqueId then
		heroVo = DataCenter.heroData:getItemByUniqueId(heroId);
	else
		heroVo = Lua_HeroVo.new(heroId);
	end

	if heroVo == nil then
		return;
	end

	local modelPosDic = DataCenter.kunXuHolyLandUtil.modelPosList;
	local data = HeroData();
    data.kind = Lua_ThingDefine.HERO;
    data.isShowName = false;
    data.isShowHpBar = false;
    data.isShowBuffIcon = false;
    data.canBeClick = false;
    data.roleId = heroId;
    data.objId = heroVo.id;
    data.hp = 1;
    data.sceneId = self.winSceneId;
    if heroVo.clothes_id ~= nil then
    	data.fashion_id = tonumber(tostring(heroVo.clothes_id));
    end
    data.dir = index <= 2 and -90 or 90;
    data.px = modelPosDic[index][1];
    data.py = modelPosDic[index][2];
    data.pz = modelPosDic[index][3];
    data.canDrag = false;
    data.showShadow = false;
    data.bPlanarShadow = true;
    data.toLand = false;
    data.isUIHeadInfo = false;
    data.shenbingId = heroVo.weapon_id;
    data:refreshShowPos();
    ThingUtil.instance:addAnimal(data, true);
end

function Lua_KunXuHolyLandEmbattleWindow:dispose()
	DataCenter.preLoadData:removeBySign("Lua_KunXuHolyLandLineupWindow", self, self.onSceneShow);
	if self.descList ~= nil then
		for k, v in pairs(self.descList) do
			v:dispose();
			v = nil;
		end
		self.descList = nil;
	end

	if self.leftMonsterNum ~=nil then
		self.leftMonsterNum:dispose();
		self.leftMonsterNum = nil;
	end
	if self.rightMonsterNum ~=nil then
		self.rightMonsterNum:dispose();
		self.rightMonsterNum = nil;
	end
	if self.leftPlayerNum ~=nil then
		self.leftPlayerNum:dispose();
		self.leftPlayerNum = nil;
	end
	if self.rightPlayerNum ~=nil then
		self.rightPlayerNum:dispose();
		self.rightPlayerNum = nil;
	end
	if self.levelNum ~=nil then
		self.levelNum:dispose();
		self.levelNum = nil;
	end

	self:superCall("dispose");
end
























--------------------------描述Vo----------------------
Lua_KunXuHolyLandEBDescItem = class("Lua_KunXuHolyLandEBDescItem", Lua_DisplayObject);
function Lua_KunXuHolyLandEBDescItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_KunXuHolyLandEBDescItem:buildShowItem()
	self:superCall("buildShowItem");

	self.backStarSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_label_1", -89, -1, 56 * 0.54, 56 * 0.54);
	self.descTxt = UICreate.createLabel(self.content, "", -10, 0, 100, 36, 26);
	-- self.descTxt.colorStr = Lua_ColorDefine.transColorStr("76645c");
	self.descTxt.horizontalOverflowValue = 1;
	self.descTxt.alignmentValue = 3;
	self.descTxt.effectStyle = 2;
	self.descTxt.effectColorStr = Lua_ColorDefine.transColorStr("100E0B");
	self.descTxt:setEffectDistance(2, 2);
end

function Lua_KunXuHolyLandEBDescItem:setData(data)
	if data == nil then
		return;
	end

	if data.isMeet then
		if self.resultSp == nil then
			self.resultSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_xhd_label_004", -89, -1, 60 * 0.54, 57 * 0.54);
		end
		self.resultSp:setEnable(true);
		self.descTxt.colorStr = Lua_ColorDefine.transColorStr("37D652");
	else
		if self.resultSp ~= nil then
			self.resultSp:setEnable(false);
		end
		self.descTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
	end

	self.descTxt.text = data.desc;
end

function Lua_KunXuHolyLandEBDescItem:dispose()
	if self.backStarSp ~= nil then
		self.backStarSp:dispose();
		self.backStarSp = nil;
	end
	if self.resultSp ~= nil then
		self.resultSp:dispose();
		self.resultSp = nil;
	end
	if self.descTxt ~= nil then
		self.descTxt:dispose();
		self.descTxt = nil;
	end

	self:superCall("dispose");
end