Lua_KunXuHolyLandFQLineUpWindow = class("Lua_KunXuHolyLandFQLineUpWindow", Lua_Window);
function Lua_KunXuHolyLandFQLineUpWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_KunXuHolyLandFQLineUpWindow";
	self.skinName = "KunXuHolyLandFQLineupWindow_skin";
	self.showBlackMask = true
	self.showClose = true;
	self.btnClosePosX = 295
	self.btnClosePosY = 200
	self.isClickClose = true;

	self.lineup_type = 31; -- 英雄布阵配置表-昆墟圣地
	self.template_id = Lua_FightDefine.TEMPLATE_ID_KUNXU;
end

function Lua_KunXuHolyLandFQLineUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.perLineupNum = 6;
	self.btnClose:setLocation(321, 293);
	self.btnClose:SetDimensions(69, 70);
	self.btnClose:setAltas("common_altas_1", "xui_common_button_003_n");

	self.tipNameTxt:setLangValue(440035);
	self.tipTxt:setLangValue(440036);
	self.leftTxt:setLangValue(440037);
	self.rightTxt:setLangValue(440038);

	self:createHeroList();
	self:updateHeroList();
	self.cancelSp:addClickFuntion(self, self.hide);
	self.sureSp:addClickFuntion(self, self.onClickSureBtn);

	self:addLuaEvent("UPDATE_KUNXUFQ_LINEUPTEAM", self, self.updateHeroList);
end

function Lua_KunXuHolyLandFQLineUpWindow:createHeroList()
	if self.heroList == nil then
		self.heroList = {};
		local item;
		local startPosX, startPosY, posX, posY = -245, 73;
		local distanceX, distanceY = 99, 174;
		local row,col;
		for i = 0, self.perLineupNum * 2 -1 do
			row = Mathf.Floor(i / self.perLineupNum);
			col = i % self.perLineupNum;
			posX = startPosX + (col * distanceX);
			posY = startPosY - (row * distanceY);
			item = Lua_KunXuHolyLandFQLineUpHeroItem.new(self.content);
			item:setLocation(posX, posY);
			item:setScale(0.9, 0.9, 0.9);

			self.heroList[i + 1] = item;
		end
	end
end

function Lua_KunXuHolyLandFQLineUpWindow:updateHeroList()
	self.hasHero = false;
	self.lineupNum = 0;
	local list = {};
	local leftFightValue = 0;
	local rightFightValue = 0;
	local vo = DataCenter.heroLineupData:getLineupVo(self.lineup_type);
	local arr;
    local heroVo;
	for i = 1, #vo.lineupDic do
		arr = vo.lineupDic[i]
		for j = 1, arr:getSize() do
			if arr[j] > 0 then
				heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);

				if list[i] == nil then
					list[i] = {};
				end
				list[i][#list[i] + 1] = { uniqueId = arr[j], standIdx = i * 100 + j };
				self.lineupNum = self.lineupNum + 1;

				if i == 1 then
					leftFightValue = leftFightValue + heroVo.heroForce;
				else
					rightFightValue = rightFightValue + heroVo.heroForce;
				end
			end
		end
	end

	-- 是否仍然有英雄可上阵
	if self.hasHero == false then
		self.hasHero = DataCenter.heroLineupData:checkPackHaveHero(vo.lineupDic);
	end

    self.leftFightTxt.text = leftFightValue;
    self.rightFightTxt.text = rightFightValue;

    for k, v in pairs(list) do
    	table.sort( v, function(a, b) return a.standIdx < b.standIdx; end );
    end

	local obj = list[1];
	local singleData;
	for i = 1, self.perLineupNum do
		singleData = obj ~= nil and obj[i] or nil;
		self.heroList[i]:setData(singleData);
	end
	
	obj = list[2];
	for i = 1, self.perLineupNum do
		singleData = obj ~= nil and obj[i] or nil;
		self.heroList[i + self.perLineupNum]:setData(singleData);
	end
end

function Lua_KunXuHolyLandFQLineUpWindow:onStartFight()
	Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sQuickFight();
	self:hide();
end

--开始战斗
function Lua_KunXuHolyLandFQLineUpWindow:onClickSureBtn(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();

    local recordId = DataCenter.fightData:getRecordIdByTemplateId(self.template_id);
    if recordId > 0 then
    	OperateAlert.showLangValue(440039);
        return;
    end
    
	self:onCheckLineup();
end

function Lua_KunXuHolyLandFQLineUpWindow:onCheckLineup()
    if self.lineupNum == 0 then
        OperateAlert.showLangValue(126307);
        return;
    end

    if self.lineupNum < 10 and self.hasHero then
        local tipsData = { des = 126312, btnType = 1, owner = self, sureFun = self.onStartFight };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;
    end

    self:onStartFight();
end

function Lua_KunXuHolyLandFQLineUpWindow:dispose()
	self.clickTime = nil;
	if self.heroList ~= nil then
		for i = 1, self.perLineupNum * 2 do
			self.heroList[i]:dispose();
			self.heroList[i] = nil;
		end
		self.heroList = nil;
	end
	self:superCall("dispose");
end

























--------------------------heroItem----------------------
Lua_KunXuHolyLandFQLineUpHeroItem = class("Lua_KunXuHolyLandFQLineUpHeroItem", Lua_DisplayObject);
function Lua_KunXuHolyLandFQLineUpHeroItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_KunXuHolyLandFQLineUpHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.addHeroSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_itembg_0", 0, 0, 124 * 0.88, 124 * 0.88);
	self.addSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_label_11", 0, 0, 42, 42);

	self.addHeroSp:addClickFuntion(self, self.onClickAddHeroSp);
end

function Lua_KunXuHolyLandFQLineUpHeroItem:setData(data)
	if data == nil then
		self.addSp:setEnable(true);
		self.addHeroSp:setEnable(true);
		if self.heroItem ~= nil then
			self.heroItem:setEnable(false);
		end
	else
		if self.heroItem == nil then
			self.heroItem = Lua_ItemIcon.new(self.content);
			self.heroItem:setLocation(0, 0);
			self.heroItem:setClick(self, self.onClickAddHeroSp);
			self.heroItem:setScale(0.88, 0.88);
		end
		local heroVo = DataCenter.heroData:getItemByUniqueId(data.uniqueId);
		self.heroItem:setData(heroVo);
		self.heroItem:setEnable(true);
		self.addSp:setEnable(false);
		self.addHeroSp:setEnable(false);
	end

end

function Lua_KunXuHolyLandFQLineUpHeroItem:onClickAddHeroSp()
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_KUNXU);
	DataCenter.preLoadData:preShowScene("Lua_KunXuHolyLandLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_KunXuHolyLandFQLineUpHeroItem:onSceneShow(param)
	local data = { 
		template_id = Lua_FightDefine.TEMPLATE_ID_KUNXU, 
		monster_player_id = nil,
		teamIndex = 1,
		stage_id = nil
		 };
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end

function Lua_KunXuHolyLandFQLineUpHeroItem:dispose()
	if self.addHeroSp ~= nil then
		self.addHeroSp:dispose();
		self.addHeroSp = nil;
	end
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end

	self:superCall("dispose");
end