Lua_KunXuHolyLandLevelWindow = class("Lua_KunXuHolyLandLevelWindow", Lua_Window);
function Lua_KunXuHolyLandLevelWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_KunXuHolyLandLevelWindow";
	self.skinName = "KunXuHolyLandLevelWindow_skin";
	self.showBlackMask = true
	self.isClickClose = true;
	self.showClose = true;

	self.imgUrl = "/images/common/xui_common_window_002.png";
	self:addPreLoadRes(self.imgUrl, Lua_LoadFileType.IMG);
end

function Lua_KunXuHolyLandLevelWindow:buildShowItem()
	self:superCall("buildShowItem");


	self.winBg:setUrl(self.imgUrl);
	self.btnClose:setLocation(319, 405);
	self.btnClose:SetDimensions(69, 70);
	self.btnClose:setAltas("common_altas_1", "xui_common_button_002_n");

	self.tipName:setLangValue(440005);

	self.levelList = Lua_DragList.new(self.content, 627, 661, Lua_AxisDefine.Vertical);
	self.levelList:setListCell(Lua_KunXuHolyLandLevelItem, 627, 100, 1);
    self.levelList:setLocation(0, -34, 0);

    local curStageVo = DataCenter.kunXuHolyLandData.curStageVo;
    local list = curStageVo.levelIdList;
    self.levelList:setArrayData(list);

    self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_KunXuHolyLandLevelWindow:dispose()
	if self.levelList ~= nil then
		self.levelList:dispose();
		self.levelList = nil;
	end
	self:superCall("dispose");
end


















--------------------------关卡Vo----------------------
Lua_KunXuHolyLandLevelItem = class("Lua_KunXuHolyLandLevelItem", Lua_ListCell);
function Lua_KunXuHolyLandLevelItem:ctor(p)
    self:superCall("ctor", p, "KunXuHolyLandLevelItem_skin");
end

function Lua_KunXuHolyLandLevelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoLevelBg:addClickFuntion(self, self.onClickGotoLevel);
end

function Lua_KunXuHolyLandLevelItem:setData(data)
	if data == nil then
		return;
	end

	self.levelId = data;
	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	local starList = levelInfo.starList;
	self.levelTxt.text = levelInfo.levelName;
	local isPrefect = true;

	local UIStr;
	for i = 1, 3 do
		UIStr = "star_"..tostring(i);
		if starList[i].isMeet then
			self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_002");
		else
			isPrefect = false;
			self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_001");
		end
	end

	self.isOpen = self.levelId <= DataCenter.kunXuHolyLandData:getEnableFightLevelId();
	if self.isOpen then
		if isPrefect then
			self.stateTxt.text = "";
			self.prefectSp:setEnable(true);
			self.gotoLevelBg:setEnable(false);
		else
			self.stateTxt:setLangValue(440006);
			self.stateTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
			self.prefectSp:setEnable(false);
			self.gotoLevelBg:setEnable(true);
			self.gotoLevelBg:setAltas("common_altas_1", "xui_common_button_006_n");
		end
	else
		self.stateTxt:setLangValue(440007);
		self.stateTxt.colorStr = Lua_ColorDefine.transColorStr("6B6B6B");
		self.prefectSp:setEnable(false);
		self.gotoLevelBg:setEnable(true);
		self.gotoLevelBg:setAltas("common_altas_1", "xui_common_button_006_d");
	end
end

function Lua_KunXuHolyLandLevelItem:onClickGotoLevel()
	if DataCenter.kunXuHolyLandData.isResetTime then
		OperateAlert.showLangValue(440008);
		return;
	end
	if not self.isOpen then
		OperateAlert.showLangValue(440009);
		return;
	end
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_OPEN, self.levelId);
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLevelWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_KunXuHolyLandLevelItem:dispose()
	self:superCall("dispose");
end






