Lua_KunXuHolyLandMainWindow = class("Lua_KunXuHolyLandMainWindow", Lua_Window);
function Lua_KunXuHolyLandMainWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_KunXuHolyLandMainWindow";
	self.skinName = "KunXuHolyLandMainWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;

	self.bgWidth = 720;
    self.bgHight = 3000;
	self.rewardHeight = 30;
	self.rewardDetalSpace = 3;
	self.rewardCellHeight = self.rewardHeight + self.rewardDetalSpace;
	self.mapBgPath_1 = "/images/kunXuHolyLand/xui_kxsd_map_bg_1.jpg";
	self.mapBgPath_2 = "/images/kunXuHolyLand/xui_kxsd_map_bg_2.jpg";
	self.mapBgPath_3 = "/images/kunXuHolyLand/xui_kxsd_map_bg_3.jpg";
    self:addPreLoadRes(self.mapBgPath_1, Lua_LoadFileType.IMG);
    self:addPreLoadRes(self.mapBgPath_2, Lua_LoadFileType.IMG);
    self:addPreLoadRes(self.mapBgPath_3, Lua_LoadFileType.IMG);

    self.setImgPath_2 = "/images/kunXuHolyLand/xui_kxsd_bj_2.png";
    self:addPreLoadRes(self.setImgPath_2, Lua_LoadFileType.IMG);
end

function Lua_KunXuHolyLandMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.starBar.typeValue = 3;
	self.starBar.fillMethodValue = 1;
	self.starBar.fillOrigin = 2;

	self.backBtn:setLocation(73, 74);
	self.showImg1 = UICreate.createImage(self.content, self.setImgPath_2, 0, 0, 720, 1440 + self.adaptHeight);
	self.showImg1.siblingIndex = 0;

    self.warIcon:addClickFuntion(self, self.onClickWarBtn);
    self.rankIcon:addClickFuntion(self, self.onClickRankBtn);
    self.levelIcon:addClickFuntion(self, self.onClickLevelBtn);
    self.quickFightIcon:addClickFuntion(self, self.onClickQuickFightBtn);
    self:setWarRedPoint();

	self:addLuaEvent("UPDATE_KUNXU_STARREWARD", self, self.updateStarReward); -- 领取星级阶段奖励返回
	self:addLuaEvent("UPDATE_KUNXU_FULLPASS_REWRAD", self, self.updateDifficultPassReward); -- 领取完美通关奖励返回
	self:addLuaEvent("UPDATE_KUNXU_LEVEL_INFO", self, self.updateLevelInfo); -- 关卡信息返回
	self:addLuaEvent("UPDATE_KUNXU_MODEL_MOVE", self, self.updateModelMove); -- 模型移动
	self:addLuaEvent("UPDATE_KUNXU_REWARD_LEVEL", self, self.updateRewardLevel); -- 更新奖励关卡
	self:addLuaEvent("SHOW_KUNXU_REWARD", self, self.showRewardItems); -- 是否显示通关奖励list

	if DataCenter.kunXuHolyLandData.firstOpen == 0 or DataCenter.kunXuHolyLandData.needResetData then
		Lua_WindowUtil.openWin("Lua_KunXuHolyLandTipWindow", Lua_WinParam.ACTION_OPEN, DataCenter.kunXuHolyLandData.curStageId );
		Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sGetKunXuInfo(1); --请求活动界面信息:首次开启标志 0跳过 1开启
	else
		self:updateLevelInfo();
	end
end

function Lua_KunXuHolyLandMainWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.showImg1:SetDimensions(720, 1440 + self.adaptHeight);
	if self.scrollContainer ~= nil then
		self.subRectH = self.bgHight - self.height;
		self.scrollContainer:SetDimensions(self.width, self.height);
		self.scrollContainer:setScrollSize(0, self.subRectH);
	end
end

function Lua_KunXuHolyLandMainWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1047, true);
end

function Lua_KunXuHolyLandMainWindow:createStarBoxList()
	if self.starBoxList == nil then
		self.starBoxList = {};

		local item;
		local distance = 401 / 3;
		for i = 1, 3 do
			item = Lua_KXStarBoxItem.new(self.content);
			item:setLocationData(-311, 538 + distance * i);
			item:setRectAnchor(7);
			self.starBoxList[i] = item;
		end
	end
end

function Lua_KunXuHolyLandMainWindow:updateStarBoxList()
	local list = DataCenter.kunXuHolyLandData.curStageVo.starRewardIdList;
	for i = 1, #list do
		self.starBoxList[i]:setData(list[i]);
	end
end

function Lua_KunXuHolyLandMainWindow:isShowQuickFightIcon()
	local isShow = DataCenter.kunXuHolyLandData.canQuickFight and not (DataCenter.kunXuHolyLandData.passLevelNum == 10);
	self.quickFightIcon:setEnable(isShow);
end

-- startX = 163, startY = -236
-- disX = 163, disY = 248
function Lua_KunXuHolyLandMainWindow:createMap()
	if self.map == nil then
		self.map = {};

		self.subRectH = self.bgHight - self.height;
		self.subMinPos = -self.subRectH / 2;
		self.subMaxPox = self.subRectH / 2;
		self.distanceCellHeight = 248;

		self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, self.width, self.height);
	    self.scrollContainer.bCreateContent = true;
	    self.scrollContainer.horizontal = false;
	    self.scrollContainer.vertical = true;
	    self.scrollContainer.movementTypeValue = 2;
	    self.scrollContainer.elasticity = 0.3;
	    self.scrollContainer.inertia = true;
	    self.scrollContainer:setScrollSize(0, self.subRectH);
	    self.scrollContainer:setScrollPivot(4);

	    self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	    self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);
	    self.scrollContainer.siblingIndex = 0;
		self.sub = self.scrollContainer.scrollContent;
		self.subRect = self.scrollContainer.scrollRect;


		self.mapBg_1 = UICreate.createImage(self.sub, self.mapBgPath_1, 0, 2500, 800, 1000);
		self.mapBg_1.anchorValue = 7;
		self.mapBg_2 = UICreate.createImage(self.sub, self.mapBgPath_2, 0, 1500, 800, 1000);
		self.mapBg_2.anchorValue = 7;
		self.mapBg_3 = UICreate.createImage(self.sub, self.mapBgPath_3, 0,  500, 800, 1000);
		self.mapBg_3.anchorValue = 7;

		local posList = DataCenter.kunXuHolyLandUtil.mapPosList;
		local list = DataCenter.kunXuHolyLandData.curStageVo.levelIdList;
		local count = #list;
		local posInfo = posList[count + 1];
		local item = Lua_KunXuHolyLandSingleItem.new(self.sub);
		item:setRectSize(178, 249);
		item:setLocation(posInfo[1], posInfo[2]);
		self.map[count + 1] = item;

		for i = count, 1, -1 do 
			posInfo = posList[i];
			item = Lua_KunXuHolyLandSingleItem.new(self.sub);
			item:setRectSize(260, 257);
			item:setLocation(posInfo[1], posInfo[2]);
			-- item:setData(list[i]);
			self.map[i] = item;
		end

		local artifactVo = DataCenter.artifactUtil:getDefaultArtifact();
		self.modelEffImg = UICreate.createModelEffImg(self.sub, artifactVo.modelUrl, artifactVo.modelSrc, 21, -1382, 200, 200);
		-- self.modelEffImg.siblingIndex = 13;
		self.modelEffImg:setCamField(1, 1, 100, true);
		self.modelEffImg:setModelEffDir(180);
		self.modelEffImg:setCamPos(0, 1, -10);
		self.modelEffImg.canRot = false;
	end
end

function Lua_KunXuHolyLandMainWindow:updateModelMove()
	local passLevelNum = DataCenter.kunXuHolyLandData.passLevelNum;
	if self.lastPassLevelNum ~= passLevelNum then
		self.lastPassLevelNum = passLevelNum;
		local startPosX, startPosY;
		self.targetPosX, self.targetPosY = self.map[passLevelNum + 1].x, self.map[passLevelNum + 1].y;
		if passLevelNum == 0 then
			startPosX, startPosY = -125, -1560;
		else
			startPosX, startPosY = self.map[passLevelNum].x, self.map[passLevelNum].y;
		end
		self.modelEffImg:setLocation(startPosX, startPosY);
		self:startModelMove();
	else
		self.modelEffImg:setLocation(self.map[passLevelNum + 1].x, self.map[passLevelNum + 1].y);
	end
end

function Lua_KunXuHolyLandMainWindow:startModelMove()
	if self.isStartMove ~= true then
		self.isStartMove = true;
        DataCenter.kunXuHolyLandData.isModelMoving = true;
		Lua_CommonUtil.addTimer("Lua_KunXuHolyLandMainWindow_ModelMove", 0.01, self, self.onModelMoving);
	end
end 

function Lua_KunXuHolyLandMainWindow:endModelMove()
	if self.isStartMove == true then
        self.isStartMove = false;
        DataCenter.kunXuHolyLandData.isModelMoving = false;
        Lua_CommonUtil.removeTimer(self, self.onModelMoving);
    end
end

function Lua_KunXuHolyLandMainWindow:onModelMoving()
	local posX, posY = self.modelEffImg.rectTf.anchoredPosition.x, self.modelEffImg.rectTf.anchoredPosition.y;
	local disX, dixY = self.targetPosX - posX, self.targetPosY - posY;
	
	local distance = Mathf.Sqrt(disX * disX + dixY * dixY);
	if distance < 2 then
        self:endModelMove();
        self.modelEffImg:setLocation(self.targetPosX, self.targetPosY);
    else
        posX = (self.targetPosX - posX) * 0.1 + posX;
        posY = (self.targetPosY - posY) * 0.1 + posY;
		self.modelEffImg:setLocation(posX, posY, 0);
    end
end

function Lua_KunXuHolyLandMainWindow:updateDifficultPassReward()
	self.curStageId = DataCenter.kunXuHolyLandData.curStageId;
	local curStageVo = DataCenter.kunXuHolyLandData.curStageVo;
	local fullReward = curStageVo.fullReward;
	local fullRewardState = DataCenter.kunXuHolyLandData.fullRewardState;
	if fullReward ~= nil and fullRewardState == 1 then
		local effect = DataCenter.kunXuHolyLandUtil:getFullPassIconSpriteByState(2);
		self:showRewardSp(true);
		self:showEff(effect);
	elseif fullReward ~= nil and fullRewardState == 0 then
		self:showRewardSp(true);
		self:showEff(nil);
	else
		self:showRewardSp(false);
		self:showEff(nil);
	end
end

function Lua_KunXuHolyLandMainWindow:showRewardSp(bShow)
	if bShow then
		if self.rewardSp == nil then
			local atlas, sprite = DataCenter.kunXuHolyLandUtil:getFullPassIconSpriteByState(1);
			self.rewardSp = UICreate.createUIAtlasImage(self.content, atlas, sprite, 183, -144, 71 * 1.2, 71 * 1.2);
			self.rewardSp.anchorValue = 1;
			self.rewardSp:addClickFuntion(self, self.onPressDiffReward);
		end 
		self.rewardSp:setEnable(true);
	else
		if self.rewardSp then
			self.rewardSp:setEnable(false);
		end
	end
end

function Lua_KunXuHolyLandMainWindow:showEff(value)
	if strIsNullOrEmpty(value) then
		if self.rewardSp ~= nil then
			self.rewardSp.alpha = 1;
		end
		if self.uiEff then
			self.uiEff:setEnable(false)
		end
	else
		if self.uiEff == nil then
			self.uiEff = UICreate.createUIEffect(self.content, nil, nil, 183, -144)
			self.uiEff.anchorValue = 1;
			self.uiEff:addLuaLoadCompleteFun(self, self.onEffLoaded);
		end
		self.uiEff:setUrl("/effects/uiEffects/"..value, value);
		self.uiEff:setEnable(true);
	end
end

function Lua_KunXuHolyLandMainWindow:onEffLoaded()
	self.rewardSp.alpha = 0.01;
end

function Lua_KunXuHolyLandMainWindow:onPressDiffReward()
	if DataCenter.kunXuHolyLandData.needResetData then
		OperateAlert.showLangValue(440013);
		return;
	end
	local kunXuHolyLandData = DataCenter.kunXuHolyLandData;
	local curStageVo = kunXuHolyLandData.curStageVo;
	local fullReward = curStageVo.fullReward;
	if fullReward then
		local curTime = getTime();
		local fullRewardState =  kunXuHolyLandData.fullRewardState;
		if fullRewardState == 1 and curTime - kunXuHolyLandData.lastClickTime >= kunXuHolyLandData.deltaTime then
			kunXuHolyLandData.lastClickTime = curTime;
			Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sReceivedPerfectReward();
		else
			if fullRewardState == 0 then
				local count = #fullReward;
				local scale = 0.6;
    			local itemWidth = 124;
    			local widget = itemWidth * scale;
    			local startPosX = 183 - (count - 1) * widget / 2;
    			local startPosY = -144 - widget;
				Lua_WindowUtil.openWin("Lua_KunXuHolyLandRewardWindow", Lua_WinParam.ACTION_OPEN, {reward = fullReward, posX = startPosX, posY = startPosY, anchor = 1});
				OperateAlert.showLangValue(440040);
			end
		end
	end
end

function Lua_KunXuHolyLandMainWindow:updateMap()
	local list = DataCenter.kunXuHolyLandData.curStageVo.levelIdList;
	local curStage = DataCenter.kunXuHolyLandData.curStageId;
	local count = #list;
	for i = 1, count do
		self.map[i]:setData(list[i]);
	end
	self.map[count + 1]:setData(nil, curStage);

	self:moveToIndex();
end

function Lua_KunXuHolyLandMainWindow:updateRewardLevel()
	local list = DataCenter.kunXuHolyLandData.curStageVo.levelIdList;
	self.map[#list + 1]:updateRewardSp();
end

function Lua_KunXuHolyLandMainWindow:onMouseDownFun()
	self:removeMoveTimer();
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self.startClickTime = getTime();
	-- self.pressItem = self:checkClick();
end

function Lua_KunXuHolyLandMainWindow:onMouseUpFun()
	local dx = CommonUtil.mousePositionX - self.startMouseX;
	local dy = CommonUtil.mousePositionY - self.startMouseY;
	if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
		self:checkPressItem();
	end
end

function Lua_KunXuHolyLandMainWindow:checkPressItem()
	local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
	local len = #self.map;
	for i = 1, len do
		if self.map[i].isActive and self.map[i]:checkInBound(winPos.x, winPos.y) then
			self.map[i]:onPressClick();
			break;
		end
	end
end

function Lua_KunXuHolyLandMainWindow:moveToIndex()
	local index = DataCenter.kunXuHolyLandData.passLevelNum;
	-- if self.curLevelNum == nil then
	-- 	self.curLevelNum = -1;
	-- end

	if self.curLevelNum == nil or self.curLevelNum < index then
		if index ~= 10 then
			--local distanceY = self.height/2 / 3;
			self.targetPos = self.subMaxPox;
			local posList = DataCenter.kunXuHolyLandUtil.mapPosList;
			for i = 1, index do
				self.targetPos = self.targetPos - Mathf.Abs(posList[i][2] - posList[i + 1][2]);
			end

			self.targetPos = self.targetPos -  Mathf.Abs(self.subMinPos - posList[1][2]);
			self.targetPos = self.targetPos + self.height/9 * 5 ;
		else
			self.targetPos = self.subMinPos;
		end

		if self.targetPos > self.subMaxPox then
			self.targetPos = self.subMaxPox;
		elseif self.targetPos < self.subMinPos then
			self.targetPos = self.subMinPos;
		end
		if self.curLevelNum == nil then
			self.scrollContainer:setScrollPosition(0, self.targetPos, 0);
		else
			self:removeMoveTimer();
			self:startMoveTimer();
		end

		self.curLevelNum = index;
	end
end

function Lua_KunXuHolyLandMainWindow:startMoveTimer()
    if self.bMoveTimer ~= true then
        self.bMoveTimer = true;
        Lua_CommonUtil.addTimer("Lua_KunXuHolyLandMainWindow_Move", 0.01, self, self.onMoveTimer);
    end
end

function Lua_KunXuHolyLandMainWindow:removeMoveTimer()
    if self.bMoveTimer == true then
        self.bMoveTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onMoveTimer);
    end
end

function Lua_KunXuHolyLandMainWindow:onMoveTimer()
    local pos = self.subRect.anchoredPosition.y;
    if Mathf.Abs(pos - self.targetPos) < 2 then
        self:removeMoveTimer();
        self.scrollContainer:setScrollPosition(0, self.targetPos, 0);
    else
        pos = (self.targetPos - pos) * 0.1 + pos;
        self.scrollContainer:setScrollPosition(0, pos, 0);
    end
end

function Lua_KunXuHolyLandMainWindow:onClickWarBtn()
	-- 跳转到昆墟圣地战令
	DataCenter.funcPathUtil:gotoFunction(1071);
end

function Lua_KunXuHolyLandMainWindow:onClickRankBtn()
	DataCenter.funcPathUtil:gotoFunction(1086)
end

function Lua_KunXuHolyLandMainWindow:onClickLevelBtn()
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLevelWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_KunXuHolyLandMainWindow:onClickQuickFightBtn()
	if DataCenter.kunXuHolyLandData.isResetTime then
		OperateAlert.showLangValue(440008);
		return;
	end
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandFQLineUpWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_KunXuHolyLandMainWindow:updateTXTInfo()
	local kunXuHolyLandData = DataCenter.kunXuHolyLandData;
	local levelCount = #kunXuHolyLandData.curStageVo.levelIdList;
	local passCount = kunXuHolyLandData.passLevelNum;
	self.layerText.text = LanUtil.formateStr(440014, kunXuHolyLandData.curStageId);
	self.passLevelTxt.text = LanUtil.formateStr(440015, passCount, levelCount);

	local starCount = kunXuHolyLandData.totalStar;
	local starTotalCount = DataCenter.kunXuHolyLandUtil.totalStarCount;
	self.starBar:setMaxValue(starTotalCount);
	self.starBar:setValue(starCount);
	self.starCountTxt.text = LanUtil.formateStr(440016, starCount, starTotalCount);

	self.residueTime = DataCenter.kunXuHolyLandData.closeTick;
	-- self.starBar.label = LanUtil.formateStr("已通关关卡{1}/10", kunXuHolyLandData.totalStar);
end

function Lua_KunXuHolyLandMainWindow:startTimer()
	if self.bTiming ~= true then
		self.residueTime = DataCenter.kunXuHolyLandData.closeTick;
		self.bTiming = true;
		self:onTimer();
		self:addTimer("Lua_KunXuHolyLandMainWindow", 1, self, self.onTimer);
	end
end

function Lua_KunXuHolyLandMainWindow:endTimer()
	if self.bTiming == true then
		self.bTiming = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_KunXuHolyLandMainWindow:onTimer()
	local residueTime = self.residueTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		self.timeText.text = LanUtil.formateStr(440017, Lua_TimeTransform.transSeconds16(residueTime, true, true, true));
	else
		self.timeText.text = "";
		self:endTimer();
	end
end

-- 领取星级阶段奖励返回
function Lua_KunXuHolyLandMainWindow:updateStarReward()
	self:updateStarBoxList();
end

-- 关卡信息返回
function Lua_KunXuHolyLandMainWindow:updateLevelInfo()
    self:createStarBoxList();
    self:createMap();

	self:updateDifficultPassReward();
	self:isShowQuickFightIcon();
	self:updateStarBoxList();
	self:updateTXTInfo();
	self:updateMap();
	self:startTimer();

	if self.lastPassLevelNum == nil then
		self.lastPassLevelNum = DataCenter.kunXuHolyLandData.passLevelNum;
		self:updateModelMove();
	end
end

function Lua_KunXuHolyLandMainWindow:setWarRedPoint()
	self.rewardRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.KunXuHolyLand_War);
	self.rewardRedPoint:setLocation(101, 85, 0);
	self.rewardRedPoint:setRectAnchor(7);
end

function Lua_KunXuHolyLandMainWindow:showRewardItems()
	local bShow = self.rewardObj == nil or (not self.rewardObj.activeSelf);
	if bShow then
		local curStageVo = DataCenter.kunXuHolyLandData.curStageVo;
		if self.rewardObj == nil then
			self.rewardObj = UICreate.createGameObject(self.sub, 0, 0, 0);
			UIUtils.setObjSiblingIndex(self.rewardObj, self.modelEffImg.siblingIndex);
		end

		if self.rewardObjBg == nil then
			self.rewardObjBg = UICreate.createUIAtlasImage(self.rewardObj, "common_altas_1", "ui_common_window_009", 0, 729, 2048, 2048);
			self.rewardObjBg.alpha = 0.1;
			self.rewardObjBg:addClickFuntion(self, self.showRewardItems);
		else
			self.rewardObjBg:setEnable(true);
		end

		if self.rewardListBg == nil then
			self.rewardListBg = UICreate.createUIAtlasImage(self.rewardObj, "common_altas_1", "ui_common_window_009", 0, 0, 0, 0);
	    	self.rewardListBg.anchorValue = 7;
	    end
		local curStageVo = DataCenter.kunXuHolyLandData.curStageVo;
	    local scale = 0.6;
	    local itemWidth = 124;
	    local rewardList = curStageVo.passReward;
	    local widget = itemWidth * scale;
	    local centerPosX = 0;
	    local centerPosY = 1082;
	    local count = #rewardList;
	    local startPosX = -(centerPosX + (count - 1) * widget) / 2;

	    local item;
	    local obj;
	    for i = 1, count do
	    	obj = rewardList[i];
	    	item = self:getRewardItemByIndex(i);
	    	item:setScale(scale, scale);
	    	item:setLocation(startPosX + widget * (i - 1), centerPosY, 0);
	    	local tvo = Lua_ToolVo.createToolVo(obj[1], obj[2]);
	    	item:setData(tvo);
		end
		if count < #self.rewardList then
			for i = count + 1, #self.rewardList do
				self.rewardList[i]:setEnable(false);
			end
		end

	    local length = widget * count;
		self.rewardListBg:setLocation(centerPosX, centerPosY);
	    self.rewardListBg:SetDimensions(length + 30, widget + 24);
	    self.rewardObj:SetActive(true);
	else
		if self.rewardObj ~= nil then
			self.rewardObj:SetActive(false);
			self.rewardObjBg:setEnable(false);
		end
	end
end

function Lua_KunXuHolyLandMainWindow:getRewardItemByIndex(index)
	if self.rewardList == nil then
		self.rewardList = {};
	end

	local item = self.rewardList[index];
	if item == nil then
		item = Lua_ItemIcon.new(self.rewardObj);
		item:setRectAnchor(7);
	    item:setCanClick(true); 
	    self.rewardList[index] = item;
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_KunXuHolyLandMainWindow:dispose()
	if self.rewardObj ~= nil and IsNil(self.rewardObj) == false then
		UnityEngine.GameObject.Destroy(self.rewardObj);
		self.rewardObj = nil;
	end
	if self.starBoxList ~= nil then
		for i = 1, #self.starBoxList do
			self.starBoxList[i]:dispose();
			self.starBoxList[i] = nil;
		end
		self.starBoxList = nil;
	end
	if self.noRewardTxt ~= nil then
		self.noRewardTxt:dispose();
		self.noRewardTxt = nil;
	end
	if self.rewardSp ~= nil then
		self.rewardSp:dispose();
		self.rewardSp = nil;
	end
	if self.uiEff ~= nil then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	if self.showImg1 ~= nil then
		self.showImg1:dispose();
		self.showImg1 = nil;
	end
	if self.mapBg_1 ~= nil then
		self.mapBg_1:dispose();
		self.mapBg_1 = nil;
	end
	if self.mapBg_2 ~= nil then
		self.mapBg_2:dispose();
		self.mapBg_2 = nil;
	end
	if self.mapBg_3 ~= nil then
		self.mapBg_3:dispose();
		self.mapBg_3 = nil;
	end
	if self.rewardRedPoint ~= nil then
		self.rewardRedPoint:dispose();
		self.rewardRedPoint = nil;
	end
	if self.rewardListBg ~= nil then
		self.rewardListBg:dispose();
		self.rewardListBg = nil;
	end
	if self.rewardList ~= nil then
		for i = 1, #self.rewardList do
			self.rewardList[i]:dispose();
			self.rewardList[i] = nil;
		end
		self.rewardList = nil;
	end
	self:endTimer();
	self:endModelMove();
	self:removeMoveTimer();
	self:superCall("dispose");
end























--------------------------星级奖励阶段宝箱----------------------
Lua_KXStarBoxItem = class("Lua_KXStarBoxItem", Lua_DisplayObject);
function Lua_KXStarBoxItem:ctor(p)
    self:superCall("ctor", p );
end

function Lua_KXStarBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon = UICreate.createUIAtlasImage(self.content, "common_altas_4", "ui_djc_box_001_n", 0, 0, 71 * 1.2, 71 * 1.2);
	self.starIcon = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_xhd_label_002", 14, -23, 36 * 0.86, 35 * 0.86);
	self.starCountTxt = UICreate.createLabel(self.content, nil, -24, -23, 66, 36, 18);
	self.starCountTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.starCountTxt.effectColorStr = Lua_ColorDefine.transColorStr("43434A");
	self.starCountTxt:setEffectDistance(2, 2);
	self.starCountTxt.pivotValue = 3;
	self.starCountTxt.alignmentValue = 3;

	self.boxIcon:addClickFuntion(self, self.onClickBoxIcon);
end

function Lua_KXStarBoxItem:setData(data)
	local starRewardInfo = DataCenter.kunXuHolyLandData:getStarRewardById(data);
	self.id = starRewardInfo.starId;
	self.reward = starRewardInfo.reward;
	self.receivedStage = starRewardInfo.receivedStage;
	if self.receivedStage == 0 then	
		self.boxIcon:setAltas(starRewardInfo.altas, starRewardInfo.normalIcon);
		self:showEff(nil);
	elseif self.receivedStage == 1 then
		-- self.boxIcon:setAltas(starRewardInfo.altas, starRewardInfo.normalIcon);
		self:showEff(starRewardInfo.lightEffect);
	else
		self.boxIcon:setAltas(starRewardInfo.altas, starRewardInfo.openIcon);
		self:showEff(nil);
	end
	self.starCountTxt.text = starRewardInfo.starCondition;
end

function Lua_KXStarBoxItem:showEff(value)
	if strIsNullOrEmpty(value) then
		self.boxIcon.alpha = 1;
		if self.uiEff then
			self.uiEff:setEnable(false)
		end
	else
		if self.uiEff == nil then
			self.uiEff = UICreate.createUIEffect(self.content, nil, nil, 0, 0)
			self.uiEff:addLuaLoadCompleteFun(self, self.onEffLoaded);
		end
		self.uiEff:setUrl("/effects/uiEffects/"..value, value);
		self.uiEff:setEnable(true);
	end
end

function Lua_KXStarBoxItem:onEffLoaded()
	self.boxIcon.alpha = 0.01;
end

function Lua_KXStarBoxItem:onClickBoxIcon()
	if DataCenter.kunXuHolyLandData.needResetData then
		OperateAlert.showLangValue(440013);
		return;
	end

	if self.receivedStage == 1 then
		local curTime = getTime();
		if curTime - DataCenter.kunXuHolyLandData.lastClickTime >= DataCenter.kunXuHolyLandData.deltaTime then
			DataCenter.kunXuHolyLandData.lastClickTime = curTime;
			Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sReceivedStarReward(self.id)
		else
			OperateAlert.showLangValue(440018);
		end
	else
		local scale = 0.6;
		local itemWidth = 124;
		local startPosX = self.posX + itemWidth * scale;
		local startPosY = self.posY; 

		Lua_WindowUtil.openWin("Lua_KunXuHolyLandRewardWindow", Lua_WinParam.ACTION_OPEN, {reward = self.reward, posX = startPosX, posY = startPosY, anchor = 7});
	end
end

function Lua_KXStarBoxItem:setLocationData(posX, posY)
	self.posX = posX;
	self.posY = posY;
	self:setLocation(posX, posY);
end

function Lua_KXStarBoxItem:dispose()
	if self.boxIcon ~= nil then
		self.boxIcon:dispose();
		self.boxIcon = nil;
	end
	if self.uiEff then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	self:superCall("dispose");
end





















--------------------------关卡Item----------------------
Lua_KunXuHolyLandSingleItem = class("Lua_KunXuHolyLandSingleItem", Lua_DisplayObject);
function Lua_KunXuHolyLandSingleItem:ctor(p)
    self:superCall("ctor", p, "KunXuHolyLandSingleItem_skin" );
end

function Lua_KunXuHolyLandSingleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardSp:setEnable(false);
end

function Lua_KunXuHolyLandSingleItem:setData(data, curStage)
	if data == nil and curStage ~= nil then
		self.levelId = nil;
		self.curStage = curStage;
	elseif data ~= nil then
		self.levelId = data;
		self.curStage = nil;
	end

	local levelData = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	local starList = levelData ~= nil and levelData.starList or nil;
	local str = self.levelId == nil and "" or levelData.levelName;
	self.levelTxt.text = str;
	self:updateStarList(starList, curStage ~= nil);
	self:showLevelDisplay(curStage ~= nil);
	self:updateRewardSp();
	self:showEffect();
end

function Lua_KunXuHolyLandSingleItem:updateRewardSp()
	-- 全通奖励状态 0不可领取 1可领取 2已领取
	if self.curStage ~= nil then
		local rewardState = DataCenter.kunXuHolyLandData.passReward;
		self.rewardSp:setEnable(rewardState ~= 2);
		self:showEffect();
	end
end

function Lua_KunXuHolyLandSingleItem:showLevelDisplay(value)
	self.rewardSp:setEnable(value);
	self.baseIcon:setEnable(not value);
	if not value then
		local sprite;
		local posX, posY;
		if self.levelId % 2 == 0 then
			sprite = "xui_kxsd_level_left";
			posX, posY = 4, -33;
		else
			sprite = "xui_kxsd_level_right";
			posX, posY = 40, -39;
		end
		self.baseIcon:setAltas("kunxuholyland_altas", sprite);
		self.baseIcon:resetSize();
		self.baseIcon:setLocation(posX, posY);
	end
end

function Lua_KunXuHolyLandSingleItem:updateStarList(starList, isReward)
	local UIStr;
 	local levelData = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	for i = 1, 3 do
		UIStr = "starIcon"..tostring(i);
		if isReward then
			self[UIStr]:setEnable(false);
		else
			self[UIStr]:setEnable(true);
			if starList[i].isMeet then
				self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_002");
			else
				self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_001");
			end
		end
	end
end

function Lua_KunXuHolyLandSingleItem:checkInBound(touchX, touchY)
	local posX = self.posX or 0
	local posY = self.posY or 0
	local scaleX = self.scaleX or 1
	local scaleY = self.scaleY or 1
	local minX = posX - self.w / 2 * scaleX
	local maxX = posX + self.w / 2 * scaleX
	local minY = posY - self.h / 2 * scaleY
	local maxY = posY + self.h / 2 * scaleY
	if touchX >= minX and touchX <= maxX and touchY >= minY and touchY <= maxY then
		return true;
	end
	return false;
end

-- 点击后还原
function Lua_KunXuHolyLandSingleItem:revertScale()
	if self.levelId ~= nil then
		self.baseIcon:setScale(1, 1);
	else
		self.rewardSp:setScale(1, 1);
	end
end

function Lua_KunXuHolyLandSingleItem:onPressClick()
	local clickScale = 1.05; -- 点击时放大倍数
	local rewardState = DataCenter.kunXuHolyLandData.passReward;-- 全通奖励状态 0不可领取 1可领取 2已领取
	if self.levelId ~= nil then
		self.baseIcon:setScale(clickScale, clickScale);
		Lua_CommonUtil.delayCall(0.2, self, self.revertScale);
	elseif rewardState ~= 2 then
		self.rewardSp:setScale(clickScale, clickScale);
		Lua_CommonUtil.delayCall(0.2, self, self.revertScale);
	end
	
	if DataCenter.kunXuHolyLandData.isModelMoving then
		OperateAlert.showLangValue(440021);
		return;
	end


	if self.levelId ~= nil then
		if DataCenter.kunXuHolyLandData.isResetTime or DataCenter.kunXuHolyLandData.needResetData then
			OperateAlert.showLangValue(440008);
			return;
		end
		if self.levelId <= DataCenter.kunXuHolyLandData:getEnableFightLevelId() then
			local sceneId = Lua_SceneDefine.KUNXU_HOLYLAND;
			DataCenter.preLoadData:preShowScene("Lua_KunXuHolyLandEmbattleWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
		else
			OperateAlert.showLangValue(440009);
		end
	else
		if DataCenter.kunXuHolyLandData.needResetData then
			OperateAlert.showLangValue(440013);
			return;
		end

		if rewardState == 0 then
			Lua_MsgUtil.callFunc("SHOW_KUNXU_REWARD");
			OperateAlert.showLangValue(440022);
		elseif rewardState == 1 then
			local curTime = getTime();
			if curTime - DataCenter.kunXuHolyLandData.lastClickTime >= DataCenter.kunXuHolyLandData.deltaTime then
				DataCenter.kunXuHolyLandData.lastClickTime = curTime;
				Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sReceivedPassReward();
			else
				OperateAlert.showLangValue(440018);
			end
		else
			OperateAlert.showLangValue(440023);
		end
	end
end

function Lua_KunXuHolyLandSingleItem:showEffect()
	local rewardState = DataCenter.kunXuHolyLandData.passReward;-- 全通奖励状态 0不可领取 1可领取 2已领取
	local bShow = self.curStage ~= nil and rewardState == 1;
    if bShow then
        if self.rewardEffect == nil then
            self.rewardEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_dbx_0102", "ui_ty_dbx_0102", 0, 0);
        end
        self.rewardEffect:setEnable(true);
    else
        if self.rewardEffect ~= nil then
            self.rewardEffect:setEnable(false);
        end
    end
end

function Lua_KunXuHolyLandSingleItem:onSceneShow()
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_OPEN, self.levelId);
end

function Lua_KunXuHolyLandSingleItem:dispose()
	DataCenter.preLoadData:removeBySign("Lua_KunXuHolyLandEmbattleWindow", self, self.onSceneShow);
	Lua_CommonUtil.removeTimer(self, self.revertScale);
	if self.rewardEffect ~= nil then
        self.rewardEffect:dispose();
        self.rewardEffect = nil;
    end
	self:superCall("dispose");
end