Lua_KunXuHolyLandQuickFightWindow = class("Lua_KunXuHolyLandQuickFightWindow", Lua_Window);
function Lua_KunXuHolyLandQuickFightWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_KunXuHolyLandQuickFightWindow";
	self.skinName = "KunXuHolyLandQuickFightWindow_skin";
	self.showBlackMask = true
	self.isClickClose = true;
	self.showClose = true;

	self.showScrollWidth = 643;
	self.showScrollHeight = 662;
	self.targetPosY = 0;
	self.deltaTime = DataCenter.kunXuHolyLandUtil.quickFightDeltaTime;
end

function Lua_KunXuHolyLandQuickFightWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(319, 405);
	self.btnClose:SetDimensions(69, 70);
	self.btnClose:setAltas("common_altas_1", "xui_common_button_002_n");

	self.showNum = 0;
	self.sureBtn:addClickFuntion(self, self.hide);
	self:addLuaEvent("UPDATE_KUNXU_QUICKFIGHT_LEVELINFO", self, self.updateLevelList);
	self:addLuaEvent("UPDATE_KUNXU_QUICKFIGHT_END", self, self.updateListMovingEnd);
end

function Lua_KunXuHolyLandQuickFightWindow:showWin(param)
	self:superCall("showWin", param);

	self.levelNum = param;
	self:createScroll();
	self:updateLevelList();
end

function Lua_KunXuHolyLandQuickFightWindow:updateListMovingEnd(levelId)
	if levelId == nil then
		return;
	end
	if self.levelNum == (levelId % 100) then
		DataCenter.kunXuHolyLandData.quickFightEndMoving = true;
	end
end

function Lua_KunXuHolyLandQuickFightWindow:updateLevelList()
	local curStageVo = DataCenter.kunXuHolyLandData.curStageVo;
    self.list = curStageVo.levelIdList;

    self.bgHeight = 0;
    if self.itemList == nil then
    	self.itemList = {};
    	self.posList = {};
    end
	local posY;
	local item;
	local height;
	for i = 1, self.levelNum do
		item = self.itemList[i];
		if item == nil then
			item = Lua_KunXuHolyLandQFLevelItem.new(self.sub);
			item:setRectAnchor(1);
			item:setEnable(false);
			self.itemList[i] = item;
		end
		item:setData(self.list[i]);

		-- 记录位置
		height = item:getHeight();
		posY = - self.bgHeight - height/ 2;
		self.posList[i] = {0, posY};
		self.bgHeight = self.bgHeight + height;
		item:setRectSize(item:getWidth(), height);
		if DataCenter.kunXuHolyLandData.quickFightEndMoving then
			item:setLocation(0, posY);
		end
	end

	self.subRectH = self.bgHeight < self.showScrollHeight and 0 or self.bgHeight - self.showScrollHeight;
	self.subMinPos = -self.subRectH / 2;
	self.subMaxPox = self.subRectH / 2;
	self.scrolllContent:setScrollSize(0, self.subRectH);
	if self.firstShow == nil then
		self.firstShow = true;
		self.scrolllContent:setScrollPosition(0, self.subMinPos, 0);
	end

	if not DataCenter.kunXuHolyLandData.quickFightEndMoving then
		self:startShow();
	end
end

function Lua_KunXuHolyLandQuickFightWindow:createScroll()
	if self.scrolllContent == nil then
		self.scrolllContent = {};
		self.scrolllContent = UICreate.createScrollContainer(self.content, 0, 0, self.showScrollWidth, self.showScrollHeight);
	    self.scrolllContent.bCreateContent = true;
	    self.scrolllContent.horizontal = false;
	    self.scrolllContent.vertical = true;
	    self.scrolllContent.movementTypeValue = 2;
	    self.scrolllContent.elasticity = 0.3;
	    self.scrolllContent.inertia = true;
	    -- self.scrolllContent:setScrollSize(0, self.subRectH);
	    self.scrolllContent:setScrollPivot(4);
	    self.scrolllContent:setLocation(0, -35);
	    self.scrolllContent:addMask(); 

	    self.scrolllContent.siblingIndex = 2;
		self.sub = self.scrolllContent.scrollContent;
		self.subRect = self.scrolllContent.scrollRect;
	end
end

function Lua_KunXuHolyLandQuickFightWindow:calHeight()

end

function Lua_KunXuHolyLandQuickFightWindow:startShow()
	if self.isShow ~= true then
		self.isShow = true;
		self:onShow();
		Lua_CommonUtil.addTimer("Lua_KunXuHolyLandQuickFightWindow", self.deltaTime, self, self.onShow);
	end
end

function Lua_KunXuHolyLandQuickFightWindow:onShow()
	local curPos;
	local index = self.showNum + 1;
	if index <= self.levelNum then
		self.showNum = index;
		curPos = index <= 1 and self.posList[1] or self.posList[index - 1];
		self.itemList[index]:setMovingData(curPos, self.posList[index]);
		if Mathf.Abs(self.posList[index][2] - self.posList[1][2]) >= self.subRectH then 
			self:startMoveTimer();
		end
	else
		self:endShow();
	end
end

function Lua_KunXuHolyLandQuickFightWindow:endShow()
	if self.isShow == true then
		self.isShow = false;
		Lua_CommonUtil.removeTimer(self, self.onShow);
	end
end

function Lua_KunXuHolyLandQuickFightWindow:startMoveTimer()
    if self.bMoveTimer ~= true then
        self.bMoveTimer = true;
        Lua_CommonUtil.addTimer("Lua_KunXuHolyLandMainWindow_ScrollMoving", 0.01, self, self.onMoveTimer);
    end
end

function Lua_KunXuHolyLandQuickFightWindow:removeMoveTimer()
    if self.bMoveTimer == true then
        self.bMoveTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onMoveTimer);
    end
end

function Lua_KunXuHolyLandQuickFightWindow:onMoveTimer()
	self.targetPosY = self.targetPosY - 130;
	if self.targetPosY < self.subMaxPox then
		self.targetPosY = self.subMaxPox;
	elseif self.targetPosY > self.subMinPos then
		self.targetPosY = self.subMinPos;
	end

    local pos = self.subRect.anchoredPosition.y;
    if Mathf.Abs(pos - self.targetPosY) < 2 then
        self:removeMoveTimer();
        self.scrolllContent:setScrollPosition(0, self.targetPosY, 0);
    else
        pos = (self.targetPosY - pos) * 0.02 + pos;
        self.scrolllContent:setScrollPosition(0, pos, 0);
    end
end


function Lua_KunXuHolyLandQuickFightWindow:hide()
	if not DataCenter.kunXuHolyLandData.quickFightEndMoving then
		OperateAlert.showLangValue(440029);
		return;
	end
	self:superCall("hide");
end

function Lua_KunXuHolyLandQuickFightWindow:dispose()
	self:removeMoveTimer();
	self:endShow();
	if self.itemList ~= nil then
		for k, v in pairs(self.itemList) do
			v:dispose();
			v = nil;
		end
		self.itemList = nil;
	end
	if self.posList ~= nil then
		self.posList = nil;
	end
	if self.scrolllContent ~= nil then
		self.scrolllContent:dispose();
		self.scrolllContent = nil;
	end

	DataCenter.kunXuHolyLandData.quickFightEndMoving = nil;
	DataCenter.kunXuHolyLandData:resetQuickFight();
	self:superCall("dispose");
end















--------------------------关卡Vo----------------------
Lua_KunXuHolyLandQFLevelItem = class("Lua_KunXuHolyLandQFLevelItem", Lua_ListCell);
function Lua_KunXuHolyLandQFLevelItem:ctor(p)
    self:superCall("ctor", p, "KunXuHolyLandQuickFightItem_skin");
end

function Lua_KunXuHolyLandQFLevelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showIcon:addClickFuntion(self, self.onClickShowIcon);
end

function Lua_KunXuHolyLandQFLevelItem:setData(data)
	if data == nil then
		return;
	end

	self.levelId = data;
	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	local starList = levelInfo.starList;
	self.levelTxt.text = levelInfo.levelName;
	local isPass = false;

	local UIStr;
	for i = 1, 3 do
		UIStr = "star_"..tostring(i);
		if starList[i].isCurMeet then
			self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_002");
			isPass = true;
		else
			isPrefect = false;
			self[UIStr]:setAltas("kunxuholyland_altas", "xui_xhd_label_001");
		end
	end

	self.isShowDesc = DataCenter.kunXuHolyLandData.showDescLevelId == self.levelId;
	local rotZ = self.isShowDesc and 180 or 0;
	local height = self.isShowDesc and 154 or 0;
	self.showIcon:setRot(0, 0, rotZ);
	self.contentBg:SetDimensions(627, 100 + height);
	self:showDesc(self.isShowDesc);

	local sprite = isPass and "xui_kxsd_label_5" or "xui_kxsd_label_4";
	self.resultSp:setAltas("kunxuholyland_altas", sprite);
end

function Lua_KunXuHolyLandQFLevelItem:showDesc(isShow)
	if isShow then
		if self.descObj == nil then
			self.descObj = UICreate.createGameObject(self.content, 0, 0, 0);
			self.descList = {};
		end
		self.descObj:SetActive(true);
		local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
		local list = levelInfo.starList;
		local item;
		for i = 1, #list do
			item = self.descList[i];
			if item == nil then
				item = Lua_KunXuHolyLandQFDescItem.new(self.descObj);
				item:setLocation(-69, 24 - (i - 1) * 50);
				self.descList[i] = item;
			end
			item:setData(list[i], i);
		end
	else
		if self.descObj ~= nil then
			self.descObj:SetActive(false);
		end
	end
end

function Lua_KunXuHolyLandQFLevelItem:getWidth()
	return 627;
end

function Lua_KunXuHolyLandQFLevelItem:getHeight()
	return self.isShowDesc and 100 + 154 or 100;
end

function Lua_KunXuHolyLandQFLevelItem:onClickShowIcon()
	if DataCenter.kunXuHolyLandData.quickFightEndMoving then
		local showDescLevelId = DataCenter.kunXuHolyLandData.showDescLevelId;
		if showDescLevelId == self.levelId then
			DataCenter.kunXuHolyLandData.showDescLevelId = nil;
		else
			DataCenter.kunXuHolyLandData.showDescLevelId = self.levelId;
		end
		-- local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
		-- levelInfo.isShowDesc = not levelInfo.isShowDesc;
		Lua_MsgUtil.callFunc("UPDATE_KUNXU_QUICKFIGHT_LEVELINFO");
	else
		OperateAlert.showLangValue(440029);
	end
end

function Lua_KunXuHolyLandQFLevelItem:setMovingData(curPos, targetPos)
	self.orginPos = curPos;
	self.targetPos = targetPos;
	self.distance = { self.targetPos[1] - self.orginPos[1], self.targetPos[2] - self.orginPos[2]};
	self:setEnable(true);
	self:startMove();
end

function Lua_KunXuHolyLandQFLevelItem:startMove()
	if self.bStartMove ~= true then
		self.bStartMove = true;
		self.index = 0;
		self:setLocation(self.orginPos[1], self.orginPos[2]);
		self:onMoving();
		Lua_CommonUtil.addTimer("Lua_KunXuHolyLandQFLevelItem"..self.levelId, DataCenter.kunXuHolyLandUtil.quickFightDeltaTime/10, self, self.onMoving);
	end
end

function Lua_KunXuHolyLandQFLevelItem:endMove()
	if self.bStartMove == true then
		Lua_CommonUtil.removeTimer(self, self.onMoving);
	end
end

function Lua_KunXuHolyLandQFLevelItem:onMoving()
	self.index = self.index + 1;
	local orginPosX, orginPosY = self.orginPos[1], self.orginPos[2];
	local disX, disY = self.targetPos[1] - self.x, self.targetPos[2] - self.y;
	local distance = Mathf.Sqrt(disX * disX + disY * disY);

	if distance > 2 then
		self:setLocation(orginPosX + self.distance[1] * 0.1 * self.index, orginPosY + self.distance[2] * 0.1 * self.index);
	else
		self:setLocation(self.targetPos[1], self.targetPos[2]);
		self:endMove();
		Lua_MsgUtil.callFunc("UPDATE_KUNXU_QUICKFIGHT_END", self.levelId);
	end
end

function Lua_KunXuHolyLandQFLevelItem:dispose()
	self:endMove();
	if self.descObj ~= nil and IsNil(self.descObj) == false then
		if self.descList ~= nil then
			for k, v in pairs(self.descList) do
				v:dispose();
				v = nil;
			end
			self.descList = nil;
		end
		UnityEngine.GameObject.Destroy(self.descObj);
		self.descObj = nil;
	end

	self:superCall("dispose");
end

























--------------------------描述Vo----------------------
Lua_KunXuHolyLandQFDescItem = class("Lua_KunXuHolyLandQFDescItem", Lua_ListCell);
function Lua_KunXuHolyLandQFDescItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_KunXuHolyLandQFDescItem:buildShowItem()
	self:superCall("buildShowItem");

	self.resultSp = UICreate.createUIAtlasImage(self.content, nil, nil, -96, 0, 36, 36);
	self.contentBg = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_widget_19", 20, 0, 360, 34);
	self.descTxt = UICreate.createLabel(self.content, "", -16, 0, 100, 32, 22);
	self.descTxt.horizontalOverflowValue = 1;
	self.descTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.descTxt.alignmentValue = 3;
	self.descTxt.fontSize = 22;
end

function Lua_KunXuHolyLandQFDescItem:setData(data, index)
	if data == nil then
		return;
	end

	local str;
	if data.isCurMeet then
		self.resultSp:setAltas("kunxuholyland_altas", "xui_kxsd_widget_8");
		self.resultSp:SetDimensions(36, 38);
		str = Lua_ColorDefine.transColorStr("469252");
	else
		self.resultSp:setAltas("kunxuholyland_altas", "xui_kxsd_widget_9");
		self.resultSp:SetDimensions(39, 39);
		str = Lua_ColorDefine.transColorStr("7E6857");
	end

	self.descTxt.colorStr = str;
	self.descTxt.text = data.desc;

	self.contentBg:setEnable(index % 2 ~= 0);
end

function Lua_KunXuHolyLandQFDescItem:dispose()
	if self.resultSp ~= nil then
		self.resultSp:dispose();
		self.resultSp = nil;
	end
	if self.descTxt ~= nil then
		self.descTxt:dispose();
		self.descTxt = nil;
	end
	if self.contentBg ~= nil then
		self.contentBg:dispose();
		self.contentBg = nil;
	end

	self:superCall("dispose");
end

