Lua_KunXuHolyLandRewardWindow = class("Lua_KunXuHolyLandRewardWindow", Lua_Window)
function Lua_KunXuHolyLandRewardWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_KunXuHolyLandRewardWindow";
    self.showBlackMask = true;
    self.isFullSizeWin = true;
    self.isClickClose = true;
    self.blackAlpha = 0.1;
end

function Lua_KunXuHolyLandRewardWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.winBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_009", 0, 0, 0, 0);
    

    -- self.rewardList = Lua_DragList.new(self.content, 200, 68, Lua_AxisDefine.Horizontal);
    -- self.rewardList:setListCell(Lua_KXRewardItem, 68, 68, 1);
    -- self.rewardList.canDrag = false;
end

function Lua_KunXuHolyLandRewardWindow:showWin(data)
    if data == nil then
        return;
    end
    self.rewardList = {};

    local anchor = data.anchor ~= nil and data.anchor or 4;
    self.winBg.anchorValue = anchor;
    local scale = 0.6;
    local itemWidth = 124;
    local rewardList = data.reward;
    local widget = itemWidth * scale;
    local startPosX = data.posX;
    local centerPosY = data.posY;
    local count = #rewardList;
    local length = widget * count;
    local winBgPosX = startPosX + length / 2 - widget / 2;

    local item;
    local obj;
    for i = 1, count do
    	obj = rewardList[i];
    	item = Lua_ItemIcon.new(self.content);
    	self.rewardList[i] = item;
        item:setRectAnchor(anchor);
        item:setLocation(startPosX + widget * (i - 1), centerPosY, 0);
	    item:setScale(scale, scale);
	    item:setCanClick(true); 

	    local tvo = Lua_ToolVo.createToolVo(obj[1], obj[2]);
    	item:setData(tvo);
	end

	self.winBg:setLocation(winBgPosX, centerPosY);
    self.winBg:SetDimensions(length + 30, itemWidth * scale + 24);
end

function Lua_KunXuHolyLandRewardWindow:dispose()
    if self.rewardList ~= nil then
        for k, v in pairs(self.rewardList) do
        	v:dispose();
        	v = nil;
        end
        self.rewardList = nil;
    end

    self:superCall("dispose");
end





--------------------------------------------------





-- Lua_KXRewardItem = class("Lua_KXRewardItem", Lua_DisplayObject);
-- function Lua_KXRewardItem:ctor(p)
--     self:superCall("ctor", p);
-- end

-- function Lua_KXRewardItem:buildShowItem()
--     self:superCall("buildShowItem");

--     self.itemIcon = Lua_ItemIcon.new(self.content);
--     self.itemIcon:setLocation(0, 0, 0);
--     self.itemIcon:setScale(0.6, 0.6);
--     self.itemIcon:setCanClick(true);
-- end

-- function Lua_KXRewardItem:setData(data)
--     if data == nil then
--         return;
--     end
--     -- self.data = data;

--     local tvo = Lua_ToolVo.createToolVo(data[1], data[2]);
--     self.itemIcon:setData(tvo);
-- end

-- function Lua_KXRewardItem:dispose()
--     if self.itemIcon ~= nil then
--         self.itemIcon:dispose();
--         self.itemIcon = nil;
--     end

--     self:superCall("dispose");
-- end